/*	the HANOI TOWER game		*/
/*  written by Antonio Bonifati	*/
/*	tabstop set to 4			*/

#include <stdio.h>

typedef unsigned int uint;
typedef unsigned long ulong;

static char *fmtstr="%3s->%-3s";
void hanoi(int n, char *l, char *c, char *r) {
	if (n<1)
		;
	else if (n==1) {
		printf(fmtstr, l, r);
	} else {
		hanoi(n-1, l, r, c);
		printf(fmtstr, l, r);
		hanoi(n-1, c, l, r);
	}
}

ulong pow2(uint exp) {
   return(1LU << exp);
}

ulong hanoi_moves(uint n) {
   return(pow2(n) - 1);
}

int main(int argc, char *argv[]) {
	int n;
	ulong m;

	if (argc==1 || (n=atoi(argv[1]))<0 || argc>2 && (n=atoi(argv[2]))<0) {
		puts("syntax: hanoi [-w] number_of_disks (range 0-31)\n"
			 "\t-w\tprint (and return) only the number of moves");
		exit(-1);
	}

	m=hanoi_moves(n);
	if (strcmp(argv[1],"-w")==0)
		printf("HANOI TOWER GAME with %d disk(s) requires %lu moves.\n", n,m);
	else {
		printf("HANOI TOWER GAME's solution with %d disk(s)\n", n);
		hanoi(n,"L","C","R");
		printf("\n# of moves: %lu\n", m);
	}
	exit(m); 
}
 
